Merge pull request #554 from deplinenoise/ppc_fixes
[mono.git] / mono / tests / Makefile.am
1 SUBDIRS = cas assemblyresolve
2
3 check-local: test
4
5 aotcheck: testaot gshared-aot
6
7 TEST_PROG = ../interpreter/mint
8
9 JITTEST_PROG = $(if $(VALGRIND), valgrind $(VALGRIND_ARGS),) $(if $(SGEN),$(top_builddir)/mono/mini/mono-sgen,$(top_builddir)/mono/mini/mono)
10
11 TEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(TEST_PROG)
12 JITTEST_PROG_RUN = MONO_SHARED_DIR=$(mono_build_root)/runtime MONO_CFG_DIR=$(mono_build_root)/runtime/etc $(LIBTOOL) --mode=execute $(JITTEST_PROG)
13
14 RUNTIME_ARGS=--config tests-config --optimize=all --debug
15
16 with_mono_path = MONO_PATH=$(mcs_topdir)/class/lib/net_4_5
17 with_mono_path_moonlight = MONO_PATH=$(mcs_topdir)/class/lib/moonlight_raw
18
19 RUNTIME = $(with_mono_path) $(top_builddir)/runtime/mono-wrapper
20 RUNTIME_MOONLIGHT = $(with_mono_path_moonlight) $(top_builddir)/runtime/mono-wrapper
21
22 MKBUNDLE = \
23         PKG_CONFIG_PATH=$(top_builddir):$(PKG_CONFIG_PATH) \
24         $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/mkbundle.exe
25
26 MCS = $(RUNTIME) $(mcs_topdir)/class/lib/build/mcs.exe -unsafe -nowarn:0162 -nowarn:0168 -nowarn:0219 -debug
27 ILASM = $(RUNTIME) $(mcs_topdir)/class/lib/net_4_5/ilasm.exe
28
29 BENCHSRC=fib.cs random.cs nested-loops.cs ackermann.cs tight-loop.cs sieve.cs
30
31 STRESS_TESTS_SRC=       \
32         abort-stress-1.cs       \
33         abort-stress-2.cs       \
34         abort-stress-3.cs       \
35         domain-stress.cs        \
36         gchandle-stress.cs      \
37         monitor-stress.cs       \
38         thread-stress.cs        \
39         gc-stress.cs            \
40         exit-stress.cs          \
41         process-stress.cs       \
42         assembly-load-stress.cs
43
44 # Disabled until ?mcs is fixed
45 #       bug-331958.cs
46 BASE_TEST_CS_SRC=               \
47         bug-2907.cs             \
48         array-init.cs           \
49         arraylist.cs            \
50         assemblyresolve_event.cs        \
51         assemblyresolve_event3.cs       \
52         checked.cs              \
53         char-isnumber.cs        \
54         create-instance.cs      \
55         field-layout.cs         \
56         pack-layout.cs          \
57         pack-bug.cs             \
58         hash-table.cs           \
59         test-ops.cs             \
60         obj.cs                  \
61         test-dup-mp.cs          \
62         string.cs               \
63         stringbuilder.cs        \
64         switch.cs               \
65         outparm.cs              \
66         delegate.cs             \
67         bitconverter.cs         \
68         exception.cs            \
69         exception2.cs           \
70         exception3.cs           \
71         exception4.cs           \
72         exception5.cs           \
73         exception6.cs           \
74         exception7.cs           \
75         exception8.cs           \
76         exception10.cs          \
77         exception11.cs          \
78         exception12.cs          \
79         exception13.cs          \
80         exception14.cs          \
81         exception15.cs          \
82         exception16.cs          \
83         exception17.cs          \
84         typeload-unaligned.cs   \
85         struct.cs               \
86         valuetype-gettype.cs    \
87         typeof-ptr.cs           \
88         static-constructor.cs   \
89         pinvoke.cs              \
90         pinvoke2.cs             \
91         pinvoke3.cs             \
92         pinvoke11.cs            \
93         pinvoke13.cs            \
94         pinvoke17.cs            \
95         invoke.cs               \
96         invoke2.cs              \
97         runtime-invoke.cs               \
98         invoke-string-ctors.cs          \
99         reinit.cs               \
100         box.cs                  \
101         array.cs                \
102         enum.cs                 \
103         enum2.cs                \
104         property.cs             \
105         enumcast.cs             \
106         assignable-tests.cs     \
107         array-cast.cs           \
108         array-subtype-attr.cs   \
109         cattr-compile.cs        \
110         cattr-field.cs          \
111         cattr-object.cs         \
112         custom-attr.cs          \
113         double-cast.cs          \
114         newobj-valuetype.cs     \
115         arraylist-clone.cs      \
116         setenv.cs               \
117         vtype.cs                \
118         isvaluetype.cs          \
119         iface6.cs               \
120         iface7.cs               \
121         ipaddress.cs            \
122         array-vt.cs             \
123         interface1.cs           \
124         reflection-enum.cs      \
125         reflection-prop.cs      \
126         reflection4.cs          \
127         reflection5.cs          \
128         reflection-const-field.cs \
129         many-locals.cs          \
130         string-compare.cs       \
131         test-prime.cs           \
132         params.cs               \
133         reflection.cs           \
134         interface.cs            \
135         iface.cs                \
136         iface2.cs               \
137         iface3.cs               \
138         iface4.cs               \
139         iface-large.cs          \
140         virtual-method.cs       \
141         intptrcast.cs           \
142         indexer.cs              \
143         stream.cs               \
144         console.cs              \
145         shift.cs                \
146         jit-int.cs              \
147         jit-uint.cs             \
148         jit-long.cs             \
149         long.cs                 \
150         jit-ulong.cs            \
151         jit-float.cs            \
152         pop.cs                  \
153         time.cs                 \
154         appdomain.cs        \
155         appdomain1.cs           \
156         appdomain2.cs           \
157         appdomain-client.cs     \
158         appdomain-unload.cs \
159         appdomain-async-invoke.cs       \
160         loader.cs       \
161         pointer.cs              \
162         hashcode.cs             \
163         delegate1.cs            \
164         delegate2.cs            \
165         delegate3.cs            \
166         delegate5.cs            \
167         delegate6.cs            \
168         delegate7.cs            \
169         delegate8.cs            \
170         delegate9.cs            \
171         remoting1.cs            \
172         remoting2.cs            \
173         remoting3.cs            \
174         remoting4.cs            \
175         remoting5.cs            \
176         largeexp.cs             \
177         largeexp2.cs            \
178         marshalbyref1.cs        \
179         static-ctor.cs          \
180         inctest.cs              \
181         bound.cs                \
182         array-invoke.cs         \
183         test-arr.cs             \
184         decimal.cs              \
185         decimal-array.cs        \
186         marshal.cs              \
187         marshal1.cs             \
188         marshal2.cs             \
189         marshal3.cs             \
190         marshal5.cs             \
191         marshal6.cs             \
192         marshal7.cs             \
193         marshal8.cs             \
194         marshal9.cs             \
195         marshalbool.cs          \
196         marshal-valuetypes.cs   \
197         test-byval-in-struct.cs \
198         thread.cs               \
199         thread5.cs              \
200         thread6.cs              \
201         thread-static.cs        \
202         thread-static-init.cs   \
203         context-static.cs       \
204         float-pop.cs            \
205         interfacecast.cs        \
206         array3.cs               \
207         classinit.cs            \
208         classinit2.cs           \
209         synchronized.cs         \
210         async_read.cs           \
211         threadpool.cs           \
212         threadpool1.cs          \
213         threadpool-exceptions1.cs \
214         threadpool-exceptions2.cs \
215         threadpool-exceptions3.cs \
216         threadpool-exceptions4.cs \
217         threadpool-exceptions5.cs \
218         threadpool-exceptions6.cs \
219         threadpool-exceptions7.cs \
220         base-definition.cs      \
221         bug-27420.cs            \
222         bug-47295.cs            \
223         bug-46781.cs            \
224         bug-48015.cs            \
225         bug-42136.cs            \
226         bug-59286.cs            \
227         bug-70561.cs            \
228         bug-78311.cs            \
229         bug-78653.cs            \
230         bug-78656.cs            \
231         bug-77127.cs            \
232         bug-323114.cs           \
233         bug-Xamarin-5278.cs     \
234         interlocked.cs          \
235         cross-domain.cs         \
236         appdomain-exit.cs       \
237         delegate-async-exit.cs  \
238         delegate-delegate-exit.cs       \
239         delegate-exit.cs        \
240         finalizer-abort.cs      \
241         finalizer-exception.cs  \
242         finalizer-exit.cs       \
243         finalizer-thread.cs     \
244         main-exit.cs    \
245         main-returns-abort-resetabort.cs        \
246         main-returns-background-abort-resetabort.cs     \
247         main-returns-background-resetabort.cs   \
248         main-returns-background.cs      \
249         main-returns-background-change.cs       \
250         main-returns.cs         \
251         subthread-exit.cs       \
252         desweak.cs              \
253         cominterop.cs           \
254         exists.cs               \
255         handleref.cs    \
256         transparentproxy.cs \
257         dbnull-missing.cs       \
258         test-type-ctor.cs       \
259         soft-float-tests.cs     \
260         thread-exit.cs          \
261         finalize-parent.cs      \
262         assemblyresolve_event2.2.cs     \
263         interlocked-2.2.cs      \
264         pinvoke-2.2.cs          \
265         bug-78431.2.cs          \
266         bug-79684.2.cs          \
267         catch-generics.2.cs     \
268         event-get.2.cs          \
269         safehandle.2.cs         \
270         stackframes-async.2.cs          \
271         module-cctor-loader.2.cs        \
272         generics-invoke-byref.2.cs      \
273         generic-signature-compare.2.cs  \
274         generics-sharing.2.cs   \
275         shared-generic-methods.2.cs     \
276         shared-generic-synchronized.2.cs        \
277         generic-inlining.2.cs   \
278         generic-initobj.2.cs    \
279         generic-delegate.2.cs   \
280         generic-sizeof.2.cs     \
281         generic-virtual.2.cs    \
282         generic-interface-methods.2.cs  \
283         generic-array-type.2.cs \
284         generic-method-patching.2.cs    \
285         generic-static-methods.2.cs     \
286         generic-null-call.2.cs  \
287         generic-special.2.cs    \
288         generic-exceptions.2.cs \
289         generic-virtual2.2.cs   \
290         generic-valuetype-interface.2.cs        \
291         generic-getgenericarguments.2.cs        \
292         generic-type-builder.2.cs       \
293         generic-synchronized.2.cs       \
294         generic-delegate-ctor.2.cs      \
295         generic-array-iface-set.2.cs    \
296         generic-typedef.2.cs    \
297         generic-marshalbyref.2.cs       \
298         generic-xdomain.2.cs    \
299         bug-431413.2.cs \
300         bug-459285.2.cs \
301         generic-virtual-invoke.2.cs     \
302         bug-461198.2.cs \
303         generic-sealed-virtual.2.cs     \
304         generic-system-arrays.2.cs      \
305         generic-stack-traces.2.cs       \
306         generic-stack-traces2.2.cs      \
307         bug-472600.2.cs \
308         recursive-generics.2.cs \
309         bug-473482.2.cs \
310         bug-473999.2.cs \
311         bug-479763.2.cs \
312         bug-616463.cs   \
313         bug-80392.2.cs          \
314         dynamic-method-access.2.cs      \
315         dynamic-method-finalize.2.cs    \
316         bug-82194.2.cs  \
317         anonarray.2.cs  \
318         ienumerator-interfaces.2.cs     \
319         array-enumerator-ifaces.2.cs    \
320         generic_type_definition_encoding.2.cs \
321         generic_type_definition.2.cs    \
322         bug-333798.2.cs         \
323         bug-333798-tb.2.cs              \
324         bug-335131.2.cs         \
325         bug-322722_patch_bx.2.cs                \
326         bug-348522.2.cs         \
327         bug-340662_bug.cs       \
328         bug-322722_dyn_method_throw.2.cs        \
329         bug-389886-2.cs \
330         bug-325283.2.cs \
331         thunks.cs \
332         winx64structs.cs \
333         bug-349190.2.cs \
334         nullable_boxing.2.cs    \
335         valuetype-equals.cs     \
336         custom-modifiers.2.cs   \
337         bug-382986.cs   \
338         test-inline-call-stack.cs       \
339         bug-324535.cs   \
340         modules.cs      \
341         bug-81673.cs    \
342         bug-81691.cs    \
343         bug-80307.cs    \
344         bug-415577.cs   \
345         filter-stack.cs \
346         vararg2.cs      \
347         bug-389886-sre-generic-interface-instances.cs   \
348         bug-461867.cs   \
349         bug-461941.cs   \
350         bug-461261.cs   \
351         bug-400716.cs   \
352         bug-462592.cs   \
353         bug-459094.cs   \
354         generic-unloading.2.cs  \
355         generic-unloading-sub.2.cs      \
356         bug-467456.cs   \
357         appdomain-unload-callback.cs    \
358         bug-508538.cs   \
359         bug-472692.2.cs         \
360         gchandles.cs    \
361         interlocked-3.cs        \
362         interlocked-4.2.cs      \
363         appdomain-thread-abort.cs \
364         xdomain-threads.cs      \
365         w32message.cs   \
366         bug-544446.cs   \
367         gc-altstack.cs  \
368         large-gc-bitmap.cs      \
369         bug-561239.cs   \
370         bug-562150.cs   \
371         bug-575941.cs   \
372         bug-599469.cs   \
373         bug-389886-3.cs \
374         monitor.cs      \
375         dynamic-method-resurrection.cs  \
376         bug-666008.cs   \
377         bug-685908.cs   \
378         sgen-long-vtype.cs      \
379         delegate-invoke.cs      \
380         bug-696593.cs   \
381         bug-705140.cs   \
382         bug-1147.cs     \
383         mono-path.cs    \
384         bug-bxc-795.cs  \
385         bug-3903.cs     \
386         async-with-cb-throws.cs \
387         appdomain-unload-doesnot-raise-pending-events.cs        \
388         bug-6148.cs     \
389         assembly_append_ordering.cs     \
390         bug-10127.cs
391
392 TEST_CS_SRC_DIST=       \
393         $(BASE_TEST_CS_SRC)     \
394         async-exc-compilation.cs \
395         filter-stack.cs \
396         finally_guard.cs
397
398 TEST_CS_SRC_GEN = \
399         runtime-invoke.gen.cs \
400         imt_big_iface_test.cs
401
402 if AMD64
403 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
404 # #651684
405 PLATFORM_DISABLED_TESTS = finally_guard.exe
406 else
407 if X86
408 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN) async-exc-compilation.cs finally_guard.cs
409 else
410 TEST_CS_SRC = $(BASE_TEST_CS_SRC) $(TEST_CS_SRC_GEN)
411 endif
412 endif
413
414 if IA64
415 TEST_CS_SRC+=async-exc-compilation.cs filter-stack.cs
416 # bug #319249
417 PLATFORM_DISABLED_TESTS=exception17.exe
418 PLATFORM_DISABLED_TESTS+=winx64structs.exe
419 endif
420
421 if X86
422
423 if HOST_WIN32
424 PLATFORM_DISABLED_TESTS=async-exc-compilation.exe finally_guard.exe
425 endif
426
427 endif
428
429 if POWERPC
430 # bug #71274
431 PLATFORM_DISABLED_TESTS=finalizer-abort.exe finalizer-exception.exe finalizer-exit.exe
432 endif
433
434 if ARM
435 PLATFORM_DISABLED_TESTS=filter-stack.exe
436 endif
437
438 if MIPS
439 # monitor.exe is racy
440 PLATFORM_DISABLED_TESTS=filter-stack.exe monitor.exe
441 endif
442
443 if S390x
444 PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe
445 #PLATFORM_DISABLED_TESTS=dynamic-method-resurrection.exe exception17.exe
446 endif
447
448 # bug-459094.exe creates an extremely deep directory tree
449 # delegate-invoke.exe depends on 929c6bc9b6d76a273f251e6f5dfacac36e9c38bd which was
450 # reverted.
451 DISABLED_TESTS=                 \
452         delegate-async-exception.exe    \
453         bug-348522.2.exe        \
454         bug-459094.exe \
455         delegate-invoke.exe \
456         $(PLATFORM_DISABLED_TESTS)
457
458 DISABLED_TESTS_WRENCH=  \
459         $(DISABLED_TESTS)       \
460         $(PLATFORM_DISABLED_TESTS_WRENCH)       \
461         main-returns-background-resetabort.exe \
462         main-returns-background-abort-resetabort.exe    \
463         main-returns-background.exe     \
464         thread6.exe     \
465         assemblyresolve_event3.exe \
466         delegate2.exe   \
467         finally_guard.exe       \
468         finalizer-abort.exe     \
469         finalizer-exit.exe      \
470         finalizer-thread.exe \
471         appdomain-async-invoke.exe
472
473 AOT_DISABLED_TESTS=constraints-load.exe
474
475 # These only compile with MS CSC
476 TEST_CSC_SRC=                   \
477         vararg.cs
478
479 TEST_IL_SRC=                    \
480         field-access.il         \
481         method-access.il        \
482         ldftn-access.il         \
483         cpblkTest.il            \
484         vbinterface.il          \
485         calliTest.il            \
486         ckfiniteTest.il         \
487         fault-handler.il                \
488         locallocTest.il         \
489         initblkTest.il          \
490         qt-instance.il          \
491         vararg.il               \
492         bug-29859.il            \
493         bug-78549.il            \
494         static-fields-nonconst.il       \
495         reload-at-bb-end.il     \
496         test-enum-indstoreil.il \
497         filter-bug.il           \
498         even-odd.il             \
499         bug-82022.il    \
500         vt-sync-method.il       \
501         enum_types.il   \
502         invalid-token.il        \
503         call_missing_method.il  \
504         call_missing_class.il   \
505         ldfld_missing_field.il  \
506         ldfld_missing_class.il  \
507         find-method.2.il        \
508         bug-79215.2.il  \
509         bug-79956.2.il  \
510         bug-327438.2.il \
511         bug-387274.2.il \
512         bug-426309.2.il \
513         ldtoken_with_byref_typespec.2.il \
514         resolve_method_bug.2.il \
515         resolve_field_bug.2.il \
516         resolve_type_bug.2.il   \
517         generics-sharing-other-exc.2.il \
518         generic-ldobj.2.il      \
519         generic-mkrefany.2.il   \
520         generic-refanyval.2.il  \
521         generic-ldtoken.2.il    \
522         generic-ldtoken-method.2.il     \
523         generic-ldtoken-field.2.il      \
524         generic-tailcall.2.il   \
525         generic-tailcall2.2.il  \
526         generic-array-exc.2.il  \
527         generic-valuetype-newobj2.2.il  \
528         generic-valuetype-newobj.2.il   \
529         generic-constrained.2.il        \
530         generic-type-load-exception.2.il        \
531         bug-81466.il    \
532         bug457574.il    \
533         bug445361.il    \
534         bug-463303.il   \
535         bug469742.2.il  \
536         bug-528055.il   \
537         constraints-load.il     \
538         array_load_exception.il \
539         bug-481403.il   \
540         interface-with-static-method.il \
541         bug-515884.il   \
542         bug-633291.il   \
543         delegate-with-null-target.il    \
544         bug-318677.il   \
545         gsharing-valuetype-layout.il    \
546         invalid_generic_instantiation.il
547
548
549 # pre-requisite test sources: files that are not test themselves
550 # but that need to be compiled
551 PREREQ_IL_SRC=event-il.il module-cctor.il
552 PREREQ_CS_SRC=
553 PREREQ_IL_DLL_SRC=event-il.il module-cctor.il
554 PREREQ_CS_DLL_SRC=
555
556 PREREQSI_IL=$(PREREQ_IL_SRC:.il=.exe)
557 PREREQSI_CS=$(PREREQ_CS_SRC:.cs=.exe)
558 TESTSI_CS=$(TEST_CS_SRC:.cs=.exe)
559 TESTSI_IL=$(TEST_IL_SRC:.il=.exe)
560 TESTBS=$(BENCHSRC:.cs=.exe)
561 STRESS_TESTS=$(STRESS_TESTS_SRC:.cs=.exe)
562
563 EXTRA_DIST=test-driver $(TEST_CS_SRC_DIST) $(TEST_IL_SRC) \
564         $(BENCHSRC) $(STRESS_TESTS_SRC) stress-runner.pl $(PREREQ_IL_SRC) $(PREREQ_CS_SRC)
565
566 %.exe: %.il
567         $(ILASM) -out:$@ $<
568
569 %.exe: %.cs TestDriver.dll
570         $(MCS) -r:TestDriver.dll -out:$@ $<
571
572 # mkbundle works on ppc, but the pkg-config POC doesn't when run with make test
573 if POWERPC
574 test_platform:
575 else
576 # Can't use mkbundle on win32 since there is no static build there
577 # Can't run test-unhandled-exception on Windows because of all the debug popups...
578 if HOST_WIN32
579 test_platform:
580 else
581 # mkbundle uses the installed mono-2.pc so it won't work if there is no system mono
582 #test_platform: testbundle test-iomap-regression
583 test_platform:  test-iomap-regression
584 endif
585 endif
586
587 if X86
588 if HOST_WIN32
589 else
590 test_platform: test-eglib-remap
591 endif
592 endif
593
594 # Target to precompile the test executables
595 tests: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS) $(GSHARED_TESTS)
596
597 #
598 # Test that no symbols are missed in eglib-remap.h
599 #
600 OK_G_SYMBOLS='g_list\|g_slist\|g_concat_dir_and_file'
601 test-eglib-remap:
602         @echo "Testing eglib remap..."
603         @if which nm > /dev/null; then if nm $(top_builddir)/mono/mini/mono | grep -v $(OK_G_SYMBOLS) | grep 't g_'; then exit 1; else exit 0; fi; fi
604
605 #
606 # Tests that the internals in mono/io-layer/messages.c are ok by triggering the 
607 # code that checks that the table is properly sorted
608 #
609 test-messages: w32message.exe
610         > test_messages.zero
611         $(with_mono_path) $(JITTEST_PROG_RUN) w32message.exe >& w32message.allout && cmp test_messages.zero w32message.allout
612
613 if MOONLIGHT
614 test_2_1 : test-coreclr-security
615 else
616 test_2_1 :
617 endif
618
619 if AMD64
620 test-sgen : sgen-tests
621 else
622 if X86
623 test-sgen : sgen-tests
624 else
625 if ARM
626 test-sgen : sgen-tests
627 else
628 if S390x
629 test-sgen : sgen-regular-tests
630 endif
631 endif
632 endif
633 endif
634
635 test: assemblyresolve/test/asm.dll testjit test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
636 test-wrench: assemblyresolve/test/asm.dll testjit-wrench test-generic-sharing test-type-load test_platform test_2_1 test-process-exit test-sgen test-messages rm-empty-logs
637
638 # Remove empty .stdout and .stderr files for wrench
639 rm-empty-logs:
640         @echo "Removing empty logs..."
641         @find . '(' -name "*.stdout" -o -name "*.stderr" ')' -empty -exec rm {} \;
642
643 assemblyresolve/test/asm.dll:
644         $(MAKE) -C assemblyresolve prereq
645
646 TestDriver.dll:
647         $(MCS) -target:library -out:$@ $(srcdir)/../mini/TestDriver.cs
648
649 test_cs: $(TEST_PROG) $(TESTSI_CS) libtest.la
650         @failed=0; \
651         passed=0; \
652         for i in $(TESTSI_CS); do       \
653                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
654                 then \
655                         passed=`expr $${passed} + 1`; \
656                 else \
657                         if [ $$? = 2 ]; then break; fi; \
658                         failed=`expr $${failed} + 1`; \
659                 fi \
660         done; \
661         echo; echo ".cs: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
662
663 test_il: $(TEST_PROG) $(TESTSI_IL) libtest.la
664         @failed=0; \
665         passed=0; \
666         for i in $(TESTSI_IL); do       \
667                 if $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i "$(DISABLED_TESTS)" 'no-dump' $(RUNTIME_ARGS); \
668                 then \
669                         passed=`expr $${passed} + 1`; \
670                 else \
671                         if [ $$? = 2 ]; then break; fi; \
672                         failed=`expr $${failed} + 1`; \
673                 fi \
674         done; \
675         echo; echo ".il: $${passed} test(s) passed. $${failed} test(s) did not pass."; echo
676
677 testb: $(TEST_PROG) $(TESTBS)
678         for i in $(TESTBS); do  \
679                 $(srcdir)/test-driver '$(with_mono_path) $(TEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS);   \
680         done
681
682 runtest-wrench: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
683         @failed=0; \
684         passed=0; \
685         failed_tests="";\
686         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
687                 rm -f $${i}.so; \
688                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
689                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS_WRENCH)' 'dump-output' $(RUNTIME_ARGS); \
690                 then \
691                         passed=`expr $${passed} + 1`; \
692                 else \
693                         if [ $$? = 2 ]; then break; fi; \
694                         failed=`expr $${failed} + 1`; \
695                         failed_tests="$${failed_tests} $$i"; \
696                 fi \
697         done; \
698         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
699         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
700           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
701
702 runtest-managed-wrench: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
703         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS_WRENCH)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
704
705 testjit-wrench:
706         @if test x$(M) != x; then $(MAKE) runtest-managed-wrench; else $(MAKE) runtest-wrench; fi
707
708 runtest: $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
709         @failed=0; \
710         passed=0; \
711         failed_tests="";\
712         for i in $(TESTSI_CS) $(TESTBS) $(TESTSI_IL); do        \
713                 rm -f $${i}.so; \
714                 if [ x$(AOT) = x1 ]; then if echo $(AOT_DISABLED_TESTS) | grep -v -q $${i}; then $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $${i} > $${i}.aotlog 2>&1 || exit 1; fi; fi; \
715                 if $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$i '$(DISABLED_TESTS)' 'no-dump' $(RUNTIME_ARGS); \
716                 then \
717                         passed=`expr $${passed} + 1`; \
718                 else \
719                         if [ $$? = 2 ]; then break; fi; \
720                         failed=`expr $${failed} + 1`; \
721                         failed_tests="$${failed_tests} $$i"; \
722                 fi \
723         done; \
724         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
725         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
726           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
727
728 runtest-managed: test-runner.exe $(TESTSI_CS) $(TESTSI_IL) $(TESTBS) libtest.la $(PREREQSI_IL) $(PREREQSI_CS)
729         @$(RUNTIME) ./test-runner.exe -j a --disabled '$(DISABLED_TESTS)' $(TESTSI_CS) $(TESTBS) $(TESTSI_IL)
730
731 testjit:
732         @if test x$(M) != x; then $(MAKE) runtest-managed; else $(MAKE) runtest; fi
733
734 testaot:
735         @$(MAKE) AOT=1 runtest
736
737 testtrace:
738         @$(MAKE) RUNTIME_ARGS="$${RUNTIME_ARGS} --trace" runtest
739
740 testinterp:
741         @$(MAKE) JITTEST_PROG_RUN="$(TEST_PROG_RUN)" runtest
742
743 testjitspeed: $(JITTEST_PROG) $(TESTBS)
744         for i in $(TESTBS); do  \
745                 echo $$i;       \
746                 time $(JITTEST_PROG) $$i;       \
747         done
748
749 test-iomap-regression: exists.cs
750         @$(MCS) $(srcdir)/exists.cs -out:exists.exe
751         @echo "Testing exists.exe..."
752         @MONO_IOMAP=all $(RUNTIME) exists.exe
753
754 stresstest: $(STRESS_TESTS)
755         @failed=0; \
756         passed=0; \
757         failed_tests="";\
758         for i in $(STRESS_TESTS); do    \
759                 if $(srcdir)/stress-runner.pl $$i ../mini/mono $(RUNTIME_ARGS); \
760                 then \
761                         passed=`expr $${passed} + 1`; \
762                 else \
763                         if [ $$? = 2 ]; then break; fi; \
764                         failed=`expr $${failed} + 1`; \
765                         failed_tests="$${failed_tests} $$i"; \
766                 fi \
767         done; \
768         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
769         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
770           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
771
772 testbundle: console.exe
773         @echo "Testing mkbundle..."
774         @$(MKBUNDLE) --static console.exe > mkbundle.stdout
775         @$(with_mono_path) MONO_CFG_DIR=$(mono_cfg_dir) MONO_SHARED_DIR=$(mono_build_root)/runtime ./a.out >> mkbundle.stdout
776         @- rm -rf a.out
777
778 EXTRA_DIST += load-missing.il t-missing.cs load-exceptions.cs
779 test-type-load: TestDriver.dll
780         @$(ILASM) /dll /output:load-missing.dll $(srcdir)/load-missing.il > /dev/null
781         @$(MCS) -t:library -out:t.dll -d:FOUND $(srcdir)/t-missing.cs
782         @$(MCS) -r:TestDriver.dll -r:load-missing.dll -r:t.dll -out:load-exceptions.exe $(srcdir)/load-exceptions.cs
783         @$(MCS) -t:library -out:t.dll $(srcdir)/t-missing.cs
784         @echo "Testing load-exception.exe..."
785         @$(RUNTIME) load-exceptions.exe > load-exceptions.exe.stdout 2> load-exceptions.exe.stderr
786
787
788 EXTRA_DIST += sgen-bridge.cs sgen-descriptors.cs sgen-gshared-vtype.cs sgen-bridge-major-fragmentation.cs sgen-domain-unload.cs sgen-weakref-stress.cs sgen-cementing-stress.cs sgen-case-23400.cs      finalizer-wait.cs critical-finalizers.cs
789
790
791 #those are actually configurations, eg plain_sgen-descriptors.exe
792 #DISABLE_SGEN_TESTS =
793
794 SGEN_TESTS =    \
795         finalizer-wait.exe      \
796         critical-finalizers.exe \
797         sgen-descriptors.exe    \
798         sgen-gshared-vtype.exe  \
799         sgen-domain-unload.exe  \
800         sgen-weakref-stress.exe \
801         sgen-cementing-stress.exe       \
802         sgen-case-23400.exe
803
804 SGEN_CONFIGURATIONS =   \
805         "|plain"        \
806         "major=marksweep-par|ms-par"    \
807         "major=marksweep-conc|ms-conc"  \
808         "major=marksweep-conc,minor=split|ms-conc-split"        \
809         "major=marksweep-par,minor=split|ms-par-split"  \
810         "minor=split|ms-split"  \
811         "major=marksweep-par,minor=split,alloc-ratio=95|ms-par-split-95"        \
812         "minor=split,alloc-ratio=95|ms-split-95"        \
813         "major=marksweep-par,wbarrier=remset|ms-par-ssb"        \
814         "wbarrier=remset|ms-ssb"        \
815         "major=marksweep-par,minor=split,wbarrier=remset|ms-par-split-ssb"      \
816         "minor=split,wbarrier=remset|ms-split-ssb"      \
817         "major=marksweep-par,minor=split,alloc-ratio=95,wbarrier=remset|ms-par-split-ssb-95"    \
818         "minor=split,alloc-ratio=95,wbarrier=remset|ms-split-ssb-95"
819
820 #FIXME We should move to use SGEN_CONFIGURATIONS once sgen supports trailling commas or its argument list.
821 SGEN_BRIDGE_CONFIGURATIONS =    \
822         "|plain"        \
823         ",major=marksweep-conc|ms-conc" \
824         ",minor=split|ms-split"
825
826 sgen-regular-tests: $(SGEN_TESTS)
827         @failed=0; \
828         passed=0; \
829         failed_tests="";\
830         for test in $+; do      \
831                 echo "...$$test";       \
832                 for conf in $(SGEN_CONFIGURATIONS); do  \
833                         name=`echo $$conf | cut -d\| -f 2`;     \
834                         params=`echo $$conf | cut -d\| -f 1`;   \
835                         test_name="$${test}|$${name}";  \
836                         if MONO_GC_PARAMS="$$params" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);     \
837                         then \
838                                 passed=`expr $${passed} + 1`; \
839                         else \
840                                 if [ $$? = 2 ]; then break; fi; \
841                                 failed=`expr $${failed} + 1`; \
842                                 failed_tests="$${failed_tests} $$test_name"; \
843                         fi \
844                 done    \
845         done;   \
846         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
847         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
848           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
849
850 sgen-bridge-tests: sgen-bridge.exe sgen-bridge-major-fragmentation.exe
851         @failed=0; \
852         passed=0; \
853         failed_tests="";\
854         for test in $+; do      \
855                 echo "...$$test";       \
856                 for conf in $(SGEN_BRIDGE_CONFIGURATIONS); do   \
857                         name=`echo $$conf | cut -d\| -f 2`;     \
858                         params=`echo $$conf | cut -d\| -f 1`;   \
859                         test_name="$${test}|$${name}";  \
860                         if MONO_GC_PARAMS="bridge=Bridge$${params}" MONO_ENV_OPTIONS="--gc=sgen" $(srcdir)/test-driver '$(with_mono_path) $(JITTEST_PROG_RUN)' $$test_name "$(DISABLED_TESTS_SGEN)" 'dump-output' $(RUNTIME_ARGS);      \
861                         then \
862                                 passed=`expr $${passed} + 1`; \
863                         else \
864                                 if [ $$? = 2 ]; then break; fi; \
865                                 failed=`expr $${failed} + 1`; \
866                                 failed_tests="$${failed_tests} $$test_name"; \
867                         fi \
868                 done    \
869         done;   \
870         echo "$${passed} test(s) passed. $${failed} test(s) did not pass."; \
871         if [ $${failed} != 0 ]; then echo -e "\nFailed tests:\n"; \
872           for i in $${failed_tests}; do echo $${i}; done; exit 1; fi
873
874 sgen-tests: sgen-regular-tests sgen-bridge-tests
875
876
877 # Generated tests for runtime invoke
878 EXTRA_DIST += gen-runtime-invoke.cs
879 runtime-invoke.gen.exe: TestDriver.dll gen-runtime-invoke.exe
880         $(RUNTIME) gen-runtime-invoke.exe > runtime-invoke.gen.cs
881         $(MCS) -out:runtime-invoke.gen.exe -r:TestDriver.dll runtime-invoke.gen.cs
882
883 EXTRA_DIST += make-imt-test.cs
884 imt_big_iface_test.exe: TestDriver.dll make-imt-test.exe
885         $(RUNTIME) make-imt-test.exe > imt_big_iface_test.cs
886         $(MCS) -out:imt_big_iface_test.exe -r:TestDriver.dll imt_big_iface_test.cs
887
888 EXTRA_DIST += test-inline-call-stack-library.cs test-inline-call-stack.cs
889 test-inline-call-stack-library.dll: TestDriver.dll $(srcdir)/test-inline-call-stack-library.cs
890         $(MCS) -t:library -out:test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack-library.cs
891 test-inline-call-stack.exe: TestDriver.dll test-inline-call-stack-library.dll $(srcdir)/test-inline-call-stack.cs
892         $(MCS) -r:TestDriver.dll -r:test-inline-call-stack-library.dll -out:test-inline-call-stack.exe $(srcdir)/test-inline-call-stack.cs
893
894 EXTRA_DIST += unhandled-exception-base-configuration.config
895 EXTRA_DIST += unhandled-exception-legacy-configuration.config
896 EXTRA_DIST += appdomain-unload.exe.config
897 EXTRA_DIST += unhandled-exception-test-case.2.cs
898 EXTRA_DIST += unhandled-exception-test-runner.2.cs
899 unhandled-exception-test-case.1.cs: unhandled-exception-test-case.2.cs
900         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case.1.cs
901 unhandled-exception-test-case-legacy.1.cs: unhandled-exception-test-case.1.cs
902         cp unhandled-exception-test-case.1.cs unhandled-exception-test-case-legacy.1.cs
903 unhandled-exception-test-case-legacy.2.cs: unhandled-exception-test-case.2.cs
904         cp unhandled-exception-test-case.2.cs unhandled-exception-test-case-legacy.2.cs
905 unhandled-exception-config_files: unhandled-exception-base-configuration.config unhandled-exception-legacy-configuration.config
906         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.1.exe.config
907         cp unhandled-exception-base-configuration.config unhandled-exception-test-case.2.exe.config
908         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.1.exe.config
909         cp unhandled-exception-legacy-configuration.config unhandled-exception-test-case-legacy.2.exe.config
910 unhandled-exception-test-case.1.exe: unhandled-exception-test-case.1.cs
911         $(MCS) /debug unhandled-exception-test-case.1.cs
912 unhandled-exception-test-case-legacy.1.exe: unhandled-exception-test-case-legacy.1.cs
913         $(MCS) /debug unhandled-exception-test-case-legacy.1.cs
914 unhandled-exception-test-case.2.exe: unhandled-exception-test-case.2.cs
915         $(MCS) /debug unhandled-exception-test-case.2.cs
916 unhandled-exception-test-case-legacy.2.exe: unhandled-exception-test-case-legacy.2.cs
917         $(MCS) /debug unhandled-exception-test-case-legacy.2.cs
918 unhandled-exception-test-runner.2.exe: unhandled-exception-test-runner.2.cs
919         $(MCS) /debug unhandled-exception-test-runner.2.cs
920
921 test-unhandled-exception: unhandled-exception-test-runner.2.exe unhandled-exception-config_files unhandled-exception-test-case.1.exe unhandled-exception-test-case-legacy.1.exe  unhandled-exception-test-case.2.exe unhandled-exception-test-case-legacy.2.exe
922         $(RUNTIME) unhandled-exception-test-runner.2.exe RUNTIME:../mini/mono,GTC:F
923
924 # We use 'test-support-files' to handle an ordering issue between the 'mono/' and 'runtime/' directories
925 bug-80307.exe: $(srcdir)/bug-80307.cs
926         $(MCS) -r:System.Web -out:$@ $(srcdir)/bug-80307.cs
927         cd $(top_builddir)/runtime && $(MAKE) test-support-files
928
929 EXTRA_DIST += bug-81673-interface.cs
930 bug-81673.exe bug-81673-interface.dll: $(srcdir)/bug-81673.cs $(srcdir)/bug-81673-interface.cs
931         $(MCS) -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
932         $(MCS) -out:bug-81673.exe -r:bug-81673-interface.dll $(srcdir)/bug-81673.cs
933         $(MCS) -define:WITH_STOP -target:library -out:bug-81673-interface.dll $(srcdir)/bug-81673-interface.cs
934
935 EXTRA_DIST += bug-81691-a.cs bug-81691-b.cs
936 bug-81691.exe bug-81691-b.dll: $(srcdir)/bug-81691.cs $(srcdir)/bug-81691-a.cs $(srcdir)/bug-81691-b.cs
937         $(MCS) -target:library -out:bug-81691-a.dll $(srcdir)/bug-81691-a.cs
938         $(MCS) -target:library -out:bug-81691-b.dll -r:bug-81691-a.dll $(srcdir)/bug-81691-b.cs
939         $(MCS) -r:bug-81691-b.dll -out:bug-81691.exe $(srcdir)/bug-81691.cs
940         rm -f bug-81691-a.dll
941 bug-81691.exe: bug-81691-b.dll
942
943 EXTRA_DIST += bug-81466-lib.il
944 bug-81466-lib.dll: bug-81466-lib.il
945         $(ILASM) /dll /output:bug-81466-lib.dll $(srcdir)/bug-81466-lib.il
946 bug-81466.exe: bug-81466.il bug-81466-lib.dll
947         $(ILASM) /exe /output:bug-81466.exe $(srcdir)/bug-81466.il
948
949 EXTRA_DIST += bug-324535-il.il
950 bug-324535-il.dll : bug-324535-il.il
951         $(ILASM) /dll /output:bug-324535-il.dll $(srcdir)/bug-324535-il.il
952 bug-324535.exe : bug-324535.cs bug-324535-il.dll
953         $(MCS) -r:bug-324535-il.dll -out:bug-324535.exe $(srcdir)/bug-324535.cs
954
955 EXTRA_DIST += custom-modifiers.2.cs custom-modifiers-lib.il
956 custom-modifiers-lib.dll: custom-modifiers-lib.il
957         $(ILASM) /dll /output:custom-modifiers-lib.dll $(srcdir)/custom-modifiers-lib.il
958 custom-modifiers.2.exe: custom-modifiers.2.cs custom-modifiers-lib.dll
959         $(MCS) -r:custom-modifiers-lib.dll -out:custom-modifiers.2.exe $(srcdir)/custom-modifiers.2.cs
960
961 EXTRA_DIST += bug-382986-lib.cs
962 bug-382986-lib.dll: bug-382986-lib.cs
963         $(MCS) -target:library -out:$@ $(srcdir)/bug-382986-lib.cs
964 bug-382986.exe: bug-382986.cs bug-382986-lib.dll
965         $(MCS) -out:$@ -r:bug-382986-lib.dll $(srcdir)/bug-382986.cs
966
967 EXTRA_DIST += coreclr-security.cs
968
969 if MOONLIGHT
970 coreclr-security.exe : coreclr-security.cs
971         $(SMCS) -out:coreclr-security.exe $(srcdir)/coreclr-security.cs
972
973 test-coreclr-security : coreclr-security.exe
974         @echo "Testing coreclr-security.exe..."
975         @$(RUNTIME_MOONLIGHT) --security=core-clr-test coreclr-security.exe
976 endif
977
978 EXTRA_DIST += generic-unboxing.2.il
979 generic-unboxing.2.dll : generic-unboxing.2.il
980         $(ILASM) /dll /output:generic-unboxing.2.dll $(srcdir)/generic-unboxing.2.il
981
982 EXTRA_DIST += generic-boxing.2.il
983 generic-boxing.2.dll : generic-boxing.2.il generic-unboxing.2.dll
984         $(ILASM) /dll /output:generic-boxing.2.dll $(srcdir)/generic-boxing.2.il
985
986 EXTRA_DIST += generic-unbox.2.cs
987 generic-unbox.2.exe : generic-unbox.2.cs generic-unboxing.2.dll
988         $(MCS) -r:generic-unboxing.2.dll -out:$@ $(srcdir)/generic-unbox.2.cs
989
990 EXTRA_DIST += generic-box.2.cs
991 generic-box.2.exe : generic-box.2.cs generic-unboxing.2.dll generic-boxing.2.dll
992         $(MCS) -r:generic-unboxing.2.dll,generic-boxing.2.dll -out:$@ $(srcdir)/generic-box.2.cs
993
994 EXTRA_DIST += generic-delegate2.2.cs generic-delegate2-lib.2.il
995 generic-delegate2-lib.2.dll : generic-delegate2-lib.2.il
996         $(ILASM) /dll /output:$@ $(srcdir)/generic-delegate2-lib.2.il
997 generic-delegate2.2.exe : generic-delegate2.2.cs generic-delegate2-lib.2.dll
998         $(MCS) -r:generic-delegate2-lib.2.dll -out:$@ $(srcdir)/generic-delegate2.2.cs
999
1000 bug-3903.exe: bug-3903.cs
1001         $(MCS) -sdk:2 $(srcdir)/bug-3903.cs -out:$@
1002
1003 gshared: test-generic-sharing
1004
1005 gshared-aot:
1006         @$(MAKE) AOT=1 gshared
1007
1008 GSHARED_TESTS = \
1009                 generics-sharing.2.exe shared-generic-methods.2.exe     \
1010                 shared-generic-synchronized.2.exe generic-initobj.2.exe         \
1011                 generics-sharing-other-exc.2.exe generic-box.2.exe              \
1012                 generic-unbox.2.exe generic-delegate.2.exe generic-sizeof.2.exe \
1013                 generic-ldobj.2.exe generic-mkrefany.2.exe                      \
1014                 generic-refanyval.2.exe generic-ldtoken.2.exe                   \
1015                 generic-ldtoken-method.2.exe  generic-ldtoken-field.2.exe       \
1016                 generic-virtual.2.exe generic-tailcall.2.exe                    \
1017                 generic-interface-methods.2.exe generic-array-type.2.exe        \
1018                 generic-method-patching.2.exe generic-static-methods.2.exe      \
1019                 generic-null-call.2.exe generic-tailcall2.2.exe                 \
1020                 generic-array-exc.2.exe generic-special.2.exe                   \
1021                 generic-exceptions.2.exe generic-delegate2.2.exe                \
1022                 generic-virtual2.2.exe generic-valuetype-interface.2.exe        \
1023                 generic-valuetype-newobj.2.exe generic-valuetype-newobj2.2.exe  \
1024                 generic-getgenericarguments.2.exe generic-type-builder.2.exe    \
1025                 generic-synchronized.2.exe generic-delegate-ctor.2.exe          \
1026                 generic-constrained.2.exe bug-431413.2.exe                      \
1027                 generic-virtual-invoke.2.exe generic-typedef.2.exe              \
1028                 generic-marshalbyref.2.exe bug-459285.2.exe bug-461198.2.exe    \
1029                 generic-sealed-virtual.2.exe generic-system-arrays.2.exe        \
1030                 generic-stack-traces.2.exe generic-stack-traces2.2.exe          \
1031                 bug-472600.2.exe bug-473482.2.exe bug-473999.2.exe              \
1032                 bug-479763.2.exe generic-xdomain.2.exe                          \
1033                 generic-type-load-exception.2.exe bug-616463.exe        \
1034                 bug-1147.exe
1035
1036 test-generic-sharing-normal: $(GSHARED_TESTS)
1037         @for fn in $+ ; do      \
1038                 echo "Testing $$fn ...";        \
1039                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared                $$fn > $$fn.stdout || exit 1;     \
1040                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,shared         $$fn > $$fn.stdout || exit 1;     \
1041                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline        $$fn > $$fn.stdout || exit 1;     \
1042                 MONO_GENERIC_SHARING=all $(RUNTIME) -O=gshared,-inline,shared $$fn > $fn.stdout || exit 1;      \
1043                 if [ x$(AOT) = x1 ]; then MONO_GENERIC_SHARING=all $(with_mono_path) $(JITTEST_PROG_RUN) --aot --debug $$fn > /dev/null || exit 1; MONO_GENERIC_SHARING=all $(RUNTIME) $$fn > $$fn.stdout || exit 1; fi; \
1044         done
1045
1046 test-generic-sharing-managed: test-runner.exe $(GSHARED_TESTS)
1047         @$(RUNTIME) ./test-runner.exe -j a --opt-sets "gshared gshared,shared gshared,-inline gshared,-inline,shared" $(GSHARED_TESTS)
1048
1049 test-generic-sharing:
1050         @if test x$(M) != x; then $(MAKE) test-generic-sharing-managed; else $(MAKE) test-generic-sharing-normal; fi
1051
1052 EXTRA_DIST += async-exceptions.cs
1053 async-exceptions.exe : async-exceptions.cs
1054         $(MCS) -out:async-exceptions.exe $(srcdir)/async-exceptions.cs
1055 test-async-exceptions : async-exceptions.exe
1056         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:foo $$i async-exceptions.exe || exit 1; done
1057         for i in `echo 0 1 2 3 4 5 6 7 8 9 10`; do $(RUNTIME) --inject-async-exc Tests:bar $$i async-exceptions.exe || exit 1; done
1058
1059 EXTRA_DIST += modules.cs modules-m1.cs
1060 modules-m1.netmodule: modules-m1.cs
1061         $(MCS) -out:$@ /target:module $(srcdir)/modules-m1.cs
1062 modules.exe: modules.cs modules-m1.netmodule TestDriver.dll
1063         $(MCS) -out:$@ /addmodule:modules-m1.netmodule -r:TestDriver.dll $(srcdir)/modules.cs
1064
1065 # Useful if mono is compiled with --enable-shared=no
1066 patch-libtool:
1067         cp "../../libtool" .
1068         sed -e 's,build_libtool_libs=no,build_libtool_libs=yes,g' libtool > 2; mv 2 libtool
1069         sed -e 's,LIBTOOL =,LIBTOOL2 =,g' Makefile > 2 && echo "LIBTOOL = bash ./libtool" > 1 && cat 1 2 > Makefile
1070         touch libtest.c
1071
1072 EXTRA_DIST += bug-438454.cs bug-438454.exe.stdout.expected
1073 test-process-exit:
1074         @$(MCS) $(srcdir)/bug-438454.cs -out:bug-438454.exe
1075         @echo "Testing bug-438454.exe..."
1076         @$(RUNTIME) bug-438454.exe > bug-438454.exe.stdout
1077         @diff -w bug-438454.exe.stdout $(srcdir)/bug-438454.exe.stdout.expected
1078
1079 OOM_TESTS =     \
1080         gc-oom-handling.exe     \
1081         gc-oom-handling2.exe
1082
1083
1084 test-oom: $(OOM_TESTS)
1085         @for fn in $+ ; do      \
1086                 echo "Testing $$fn ...";        \
1087                 MONO_GC_PARAMS=max-heap-size=16m,major=marksweep-par MONO_ENV_OPTIONS="--gc=sgen" $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1088                 MONO_GC_PARAMS=max-heap-size=16m MONO_ENV_OPTIONS="--gc=sgen"                     $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1089                 MONO_GC_PARAMS=max-heap-size=16m                                                  $(RUNTIME) $$fn > $$fn.stdout || exit 1;      \
1090         done
1091
1092
1093 noinst_LTLIBRARIES = libtest.la
1094
1095 AM_CPPFLAGS = $(GLIB_CFLAGS) $(GMODULE_CFLAGS)
1096
1097 if HOST_WIN32
1098 # gcc-3.4.4 emits incorrect code when making indirect calls to stdcall functions using a tail call
1099 # This shows up when compiling mono_test_marshal_delegate ()
1100 libtest_la_CFLAGS=-fno-optimize-sibling-calls
1101 # the exported names created by gcc for stdcall functions are missing the leading _, so MS.NET
1102 # can't find them. So we use --kill-at to remove the @ suffix as well.
1103 libtest_la_LDFLAGS=-no-undefined -rpath `pwd` -Wl,--kill-at
1104 else
1105 libtest_la_LDFLAGS = -rpath `pwd`
1106 endif
1107 libtest_la_SOURCES = libtest.c
1108 libtest_la_LIBADD = $(GLIB_LIBS) $(LIBICONV)
1109
1110 CLEANFILES = $(TESTSI_CS) $(TESTSI_IL) $(STRESS_TESTS) *.dll *.stdout *.aotlog *.exe stest.dat